package info.hostip.dao.mgr;

import java.util.Vector;
import java.sql.*;
import info.hostip.dao.core.*;

/******************SQL2JAVA_IMPORT_BEGIN******************/

/******************SQL2JAVA_IMPORT_END********************/


/** This is the dao class.
 * @author <a href="mailto:vinodpillai@excite.com">Vinod Pillai</a>
 */
public class CountriesManager extends Manager
/******************SQL2JAVA_EXTENDS_BEGIN******************/

/******************SQL2JAVA_EXTENDS_END********************/

{

/******************SQL2JAVA_CLASS_BEGIN******************/

/******************SQL2JAVA_CLASS_END********************/


	private static CountriesManager _global = new CountriesManager();
	public static CountriesManager getManager() { return _global; }

	public static final int ID = 0;
	public static final int NAME = 1;
	public static final int CODE = 2;

	private static final String[] S2J_FIELD_NAMES = {
		"countries.id",
		"countries.name",
		"countries.code"
	};

	private static final String ALL_FIELDS = "countries.id"
                            + ",countries.name"
                            + ",countries.code";

	public Countries loadByKey(int _id) throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			Countries _val = loadByKey(_id, _conn);
			closeConnection(_conn);
			return _val;
		}
		catch(SQLException e) {
			if(_conn != null)  try { closeConnection(_conn); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Countries loadByKey(int _id, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("SELECT " + ALL_FIELDS + " FROM countries WHERE countries.id=?");
			_pstmt.setLong(1, _id);
			Countries _list[] = loadByPreparedStatement(_pstmt);
			_pstmt.close();
			if(_list.length < 1) return null;
			else                 return _list[0];
		}
		catch(SQLException e) {
			if(_pstmt != null) try { _pstmt.close(); } catch(SQLException e2) { }
			throw e;
		}
	}

	public int deleteByKey(int _id) throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			int _rows = deleteByKey(_id, _conn);
			closeConnection(_conn);
			return _rows;
		}
		catch(SQLException e) {
			if(_conn!=null) try { closeConnection(_conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public int deleteByKey(int _id, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("DELETE from countries WHERE countries.id=?");
			_pstmt.setLong(1, _id);
			int _rows = _pstmt.executeUpdate();
			_pstmt.close();
			return _rows;
		}
		catch(SQLException e) {
			if(_pstmt!=null) try { _pstmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public Countries[] loadAll() throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			Countries _list[] = loadAll(_conn);
			closeConnection(_conn);
			return _list;
		}
		catch(SQLException e) {
			if(_conn != null)  try { closeConnection(_conn); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Countries[] loadAll(Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("SELECT " + ALL_FIELDS + " FROM countries");
			Countries _list[] = loadByPreparedStatement(_pstmt);
			_pstmt.close();
			return _list;
		}
		catch(SQLException e) {
			if(_pstmt != null) try { _pstmt.close(); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Countries[] loadByPreparedStatement(PreparedStatement pstmt) throws SQLException {
		return loadByPreparedStatement(pstmt, null, 0);
	}

	public Countries[] loadByPreparedStatement(PreparedStatement pstmt, int maxRows) throws SQLException {
		return loadByPreparedStatement(pstmt, null, maxRows);
	}

	public Countries[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList) throws SQLException {
		return loadByPreparedStatement(pstmt, fieldList, 0);
	}

	public Countries[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList, int maxRows) throws SQLException {
		ResultSet rs = null;
		try {
			rs = pstmt.executeQuery();
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			Countries list[] = new Countries[v.size()];
			v.copyInto(list);
			return list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public Countries[] loadByWhere(String where) throws SQLException {
		return loadByWhere(where, (int[])null, 0);
	}
	public Countries[] loadByWhere(String where, int maxRows) throws SQLException {
		return loadByWhere(where, (int[])null, maxRows);
	}
	public Countries[] loadByWhere(String where, int[] fieldList) throws SQLException {
		return loadByWhere(where, fieldList, 0);
	}
	public Countries[] loadByWhere(String where, int[] fieldList, int maxRows) throws SQLException {
		Connection conn = null;
		try {
			conn = openConnection();
			Countries _list[] = loadByWhere(where, conn, fieldList, maxRows);
			closeConnection(conn);
			return _list;
		}
		catch(SQLException e) {
			if(conn!=null) try { closeConnection(conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public Countries[] loadByWhere(String where, Connection conn) throws SQLException {
		return loadByWhere(where, conn, null, 0);
	}

	public Countries[] loadByWhere(String where, Connection conn, int[] fieldList) throws SQLException {
		return loadByWhere(where, conn, fieldList, 0);
	}

	public Countries[] loadByWhere(String where, Connection conn, int[] fieldList, int maxRows) throws SQLException {
		String sql = null;
		if(fieldList == null) sql = "select " + ALL_FIELDS + " from countries " + where;
		else {
			StringBuffer buff = new StringBuffer(128);
			buff.append("select ");
			for(int i = 0; i < fieldList.length; i++) {
				if(i != 0) buff.append(",");
				buff.append(S2J_FIELD_NAMES[fieldList[i]]);
			}
			buff.append(" from countries ");
			buff.append(where);
			sql = buff.toString();
		}
		Statement stmt = null;
		ResultSet rs = null;
		try {
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			stmt.close();

			Countries _list[] = new Countries[v.size()];
			v.copyInto(_list);
			return _list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			if(stmt!=null) try { stmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Countries obj) throws SQLException {
		if(!obj.isModified()) return;
		Connection _conn = null;
		try {
			_conn = openConnection();
			save(obj, _conn);
			closeConnection(_conn);
		}
		catch(SQLException e) {
			if(_conn!=null) try { closeConnection(_conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Countries obj, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			if(obj.isNew()) {
				int _dirtyCount = 0;
				StringBuffer _sql = new StringBuffer("INSERT into countries (");
				if(obj.isIdModified()) {  _sql.append("id").append(","); _dirtyCount++; }
				if(obj.isNameModified()) {  _sql.append("name").append(","); _dirtyCount++; }
				if(obj.isCodeModified()) {  _sql.append("code").append(","); _dirtyCount++; }
				_sql.setLength(_sql.length() - 1);
				_sql.append(") values (");
				for(int i = 0; i < _dirtyCount; i++) _sql.append("?,");
				_sql.setLength(_sql.length() - 1);
				_sql.append(")");

				_pstmt = _conn.prepareStatement(_sql.toString());
				_dirtyCount = 0;
				if(obj.isIdModified()) { _pstmt.setLong(++_dirtyCount, obj.getId()); } 
				if(obj.isNameModified()) { _pstmt.setString(++_dirtyCount, obj.getName()); } 
				if(obj.isCodeModified()) { _pstmt.setString(++_dirtyCount, obj.getCode()); } 
				_pstmt.executeUpdate();
				_pstmt.close();
				_pstmt = _conn.prepareStatement("SELECT last_insert_id()");
				ResultSet _rs = _pstmt.executeQuery();
				if(_rs.next()) obj.setId(_rs.getInt(1));
				_rs.close();
				obj.setIsNew(false);
				obj.resetIsModified();
			}
			else {
				StringBuffer _sql = new StringBuffer("UPDATE countries SET ");
				if(obj.isIdModified()) {  _sql.append("id").append("=?,"); }
				if(obj.isNameModified()) {  _sql.append("name").append("=?,"); }
				if(obj.isCodeModified()) {  _sql.append("code").append("=?,"); }
				_sql.setLength(_sql.length() - 1);
				_sql.append(" WHERE ");
				_sql.append("countries.id=?");
				_pstmt = _conn.prepareStatement(_sql.toString());
				int _dirtyCount = 0;
				if(obj.isIdModified()) { _pstmt.setLong(++_dirtyCount, obj.getId()); } 
				if(obj.isNameModified()) { _pstmt.setString(++_dirtyCount, obj.getName()); } 
				if(obj.isCodeModified()) { _pstmt.setString(++_dirtyCount, obj.getCode()); } 
				_pstmt.setLong(++_dirtyCount, obj.getId());
				_pstmt.executeUpdate();
				obj.resetIsModified();
			}
			_pstmt.close();
		}
		catch(SQLException e) {
			if(_pstmt!=null) try { _pstmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	private Countries decodeRow(ResultSet rs) throws SQLException {
		Countries obj = new Countries();
		obj.setId(rs.getInt(1));
		obj.setName(rs.getString(2));
		obj.setCode(rs.getString(3));
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

	private Countries decodeRow(ResultSet rs, int[] fieldList) throws SQLException {
		Countries obj = new Countries();
		int pos = 0;
		for(int i = 0; i < fieldList.length; i++) {
			switch(fieldList[i]) {
				case ID: obj.setId(rs.getInt(++pos));
					break;
				case NAME: obj.setName(rs.getString(++pos));
					break;
				case CODE: obj.setCode(rs.getString(++pos));
					break;
			}
		}
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

}
